#include "hwio.h"
#include "uart.h"
#include "mailbox.h"

#define WIDTH  640
#define HEIGHT 480

static volatile void busy_wait(int32_t count) {
	while(count > 0) {
		count--;
	}
}

void main() {
	uart_init();
	uart_puts("Hello Raspberry pi. FrameBuffer Test\n");
	mailbox_fb_init(WIDTH, HEIGHT);
	uint32_t *buf = (uint32_t *)VcToArm(mailbox_fb_ptr());
	for(int y = 0; y < HEIGHT; y++) {
		for(int x = 0; x < WIDTH; x++) {
			buf[x + y * WIDTH] = x ^ y;
		}
	}
	while(1) {
		busy_wait(0x1000000);
	}
}

